@echo off

rem Le fichier original est a l'adresse http://setiathome.berkeley.edu/seti_service_V1.07.zip

echo N'oubliez pas de lire le fichier setiservice.txt

set install_version=Version francaise adaptee de seti_service.bat V1.07 (c) http://holger.hippenstiel.org

rem Repertoire ou doivent etre presents le programme seti et le fichier user_info.sah
rem "Progra~1" a utiliser pour "Programme", "Program files" et ainsi de suite... mais pas si vous etes en NTFS noms courts !
rem Preferez des noms de chemin en 8 carateres maxi pour etre tranquille.
set seti_prgpath=C:\winnt\seti

rem if you use a filename without a version, you didn't have to change it when the version changes
rem Nom du programme seti a transformer en service.
set seti_program=setiAhome.exe

rem Indiquer ici les options de lancement (par exemple -proxy @IP:nnnn ; @IP=localhost si vous utilisez SetiGate ou SetiQueue sur ce poste, nnnn = 5001 pour SetiGate).
set seti_extras=-proxy 013.013.013.001:5001

rem Indiquer ici le nom que vous voulez donner au service.
set seti_service=setiAhome

set base=HKLM\SYSTEM\CurrentControlSet\Services\

set regprg="%seti_prgpath%\%seti_program%"
if "!%seti_extras%!" == "!!" goto noextras
set regprg="%seti_prgpath%\%seti_program% %seti_extras%"
:noextras

echo %install_version%

if exist %seti_prgpath% goto pathok
echo Chemin introuvable: "%seti_prgpath%" !
goto end
:pathok

if exist %seti_prgpath%\%seti_program% goto fileok
echo Fichier introuvable: "%seti_prgpath%\%seti_program%" !
goto end
:fileok

if not "%1%" == "remove" goto noremove
reg >nul query %base%%seti_service%
if %errorlevel% == 0 goto nosetifound
echo Arret du service "%seti_service%"
sc >nul stop %seti_service%
echo Suppression du service "%seti_service%"
instsrv >nul %seti_service% remove
if not exist %SystemRoot%\srvany.exe goto end
echo NOTE: %SystemRoot%\srvany.exe n'a pas ete supprime, il est peut-etre necessaire  d'autres services !?
goto end
:noremove

if not "%1%" == "auto" goto noauto
set newtype=automatique
set newval=2
goto changetypeseti
:noauto

if not "%1%" == "manuel" goto nomanual
set newtype=manuel
set newval=3
goto changetypeseti
:nomanual

if not "%1%" == "desactive" goto nodisable
set newtype=desactive
set newval=4
goto changetypeseti
:nodisable

if not "%1%" == "stop" goto nostop
set action=Arret
set real=stop
goto changeseti
:nostop

if not "%1%" == "start" goto nostart
set action=Demarrage
set real=start
goto changeseti
:nostart

if not "%1%" == "status" goto nostatus
find >nul /i "prog=" %seti_prgpath%\state.sah
if not "%errorlevel%" == "1" goto gotstate
echo Fichier de suivi de progression non trouve, echo peut-etre ne tourne-t-il pas,
echo ou une unite de travail (WU) vient tout juste d'etre telechargee a partir du serveur.
goto end
:gotstate
find /i "prog=" %seti_prgpath%\state.sah
goto end
:nostatus

set force=off
if not "%1%" == "force" goto noforce
echo Arret du service "%seti_service%"
sc >nul stop %seti_service%
echo Suppression du service "%seti_service%"
instsrv >nul %seti_service% remove
:noforce

reg >nul query %base%%seti_service%
if not %errorlevel% == 0 goto nosetipresent
echo Le service "%seti_service%" existe deja !
echo Utiliser "seti_service force" pour le reinstaller.
goto end
:nosetipresent

if exist %SystemRoot%\srvany.exe goto nocopy
echo Copie de "srvany.exe" vers %SystemRoot%
copy >nul srvany.exe %SystemRoot%
:nocopy

echo Creation du service "%seti_service%"
instsrv >nul %seti_service% %SystemRoot%\srvany.exe
echo Le service "%seti_service%" est en demarrage automatique, mais il n'a pas ete demarre pour le moment.

set regkey=%base%%seti_service%\Parameters\Application
set regval=%regprg%
set subret=registry1
goto insertreg
:registry1

set regkey=%base%%seti_service%\Parameters\AppDirectory
set regval="%seti_prgpath%"
set subret=registry2
goto insertreg
:registry2

set regkey=%base%%seti_service%\Description
set regval="Client seti@home, entree cree avec %install_version%"
set subret=registry3
goto insertreg
:registry3

goto end

:insertreg
set mode=add
reg >nul %regkey%
if not %errorlevel% == 0 goto mode_add
set mode=update
:mode_add
reg >nul %mode% %regkey%=%regval%
goto %subret%

:changetypeseti
reg >nul query %base%%seti_service%
if not %errorlevel% == 0 goto nosetifound
echo Le type de demarrage du service "%seti_service%" va passer en mode %newtype%
reg >nul update %base%%seti_service%\Start=%newval%
goto end

:changeseti
reg >nul query %base%%seti_service%
if not %errorlevel% == 0 goto nosetifound
echo %action% du service "%seti_service%"
sc >nul %real% %seti_service%
goto end

:nosetifound
echo Service "%seti_service%" non trouve !
goto end

:end
echo Tout est termine !
echo.
echo.
echo Rappel des commandes disponibles:
echo.
echo force      Installe le service SETI meme s'il est deja present.
echo start      Demarre le service SETI.
echo stop       Arrete le service SETI.
echo remove     Desinstalle le service SETI.
echo auto       Passe le servive SETI en demarrage automatique.
echo manuel     Passe le service SETI en demarrage manuel.
echo desactive  Desactive le service SETI (ne le desinstalle pas).
echo status     Affiche l'etat actuel de progression de calcul du client seti@home (prog=0.xxxx) la valeur est en pourcentage.
